/*
 *   This removes some redundancy, and subsequenly restores it, from
 *   "/usr/src/linux/.config."
 *   Created 12-FEB-2002   Richard B. Johnson       rjohnson@analogic.com
 *   Released under GPL
 */


#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/fcntl.h>
#include <string.h>

const char conf[]="CONFIG_";

int main(int args, char *argv[]);

#define BUF_LEN 0x1000
#define ERRORS(s) \
{                 \
    fprintf(stderr, "Error from line %d, file %s, call %s, (%s)\n", \
            __LINE__,__FILE__,(s), strerror(errno));                \
}
#define X (sizeof(conf) - 1)

int main(int args, char *argv[])
{
    char last[0x100];
    FILE *in_file, *out_file;
    char *buf;
    char *cp, *ep;
    if(args < 3)
    {
        fprintf(stderr, "Usage:\n%s <infile> <outfile> [x]\n", argv[0]);
        exit(EXIT_FAILURE);
    }
    if((in_file = fopen(argv[1], "r")) == NULL)
        ERRORS("fopen");
    if((out_file = fopen(argv[2], "w")) == NULL)
        ERRORS("fopen");
    if((buf = (char *) malloc(BUF_LEN * sizeof(char))) == NULL)
        ERRORS("malloc");
    *last = (char) 0x00;
    if(args > 3)
    {
        while(fgets(buf, BUF_LEN, in_file) != NULL)
        {
            if(*buf == (char) '%')
                fprintf(out_file, "%s%s%s", conf, last, &buf[1]);
            else
            {
                fprintf(out_file, "%s%s", conf, buf);
                if((ep = strchr(buf, '_')) != NULL)
                {
                    *ep = (char) 0x00;
                    strcpy(last, buf);
                }
            }
        } 
    }
    else
    {
        while(fgets(buf, BUF_LEN, in_file) != NULL)
        {
            if(*buf == (char) '#') continue;
            if((cp = strstr(buf, conf)) != NULL)
            {
                if((*last) && strstr(cp, last))
                    fprintf(out_file, "%%%s", &cp[X + strlen(last)]);
                else
                    fprintf(out_file, &cp[X]);
                if((ep = strchr(&cp[X], '_')) != NULL)
                {
                    *ep = (char) 0x00;
                    strcpy(last, &cp[X]);
                 }
                 else
                    *last = (char) 0x00;
             }
        }
    }
    return 0;
}

